@warnings
@script master
@version 2.10
@name Octane Exporter
@asyncspawn

@define WIDTH   350
@define HEIGHT  500

VersionNumber = 3;

endFrame;
startFrame;
stepFrame;
ctl_customsamples;

m_InterpolateMode = 1;

ctl_reswidth;
ctl_resheight;
ctl_scaleres;
strItemOne = "";
strItemTwo = "";
strItemThree = "";
strItemFour = "";
strItemFive = "";
strItemSix = "";
strItemSeven = "";
strItemEight = "";
ItemFound = 0;

OctaneExePath = "";
PresetSamples = 6;
WriteUVHow = 1;
WriteNORMALHow = 1;
AnimOutputPath = "";
g_OctaneProject = "";
g_Scenename = "";

changingfromscale = false;
settingdefaultres = false;
g_ForceOBJExport = false;
OriginalWidth = 1024;
OriginalHeight = 512;
g_ResWidth = 1024;
g_ResHeight = 512;
g_Aperture = 1.0;
g_FocalDepth = 5.0;
g_Exposure = 0;
g_SelectedCamera = 1;
g_SelectedLight = 1;
g_SelectedItem = "";
g_GPU = "0";
m_MotionBlur = 0;
g_SampleCustom = 0;
g_PointOfInt = 5;
g_CameraBool = true;
g_ResolutionBool = false;
g_CheckAperture = false;
g_CheckFocal = false;
g_ExportSunDir = false;
g_CheckGPU = false;
g_WriteNORMAL = false;
g_WriteUV = true;
g_UnitSize = 4;
g_ScaleRes = 1;
WriteOBJHow = 2;

MyCam;
Multiplier;
AimposX;
AimposY;
AimposZ;
Logfile;
UseLog = false;
create
{
    setdesc("Octane Exporter");
	scene = Scene();
	endFrame = scene.previewend;
	startFrame = scene.previewstart;
	stepFrame = scene.previewstep;
	g_Scenename = Scene().name;
	g_SelectedCamera = Camera(1);
	g_SelectedLight = Light(1);
	item = Mesh();
	while(item){
		if(item.null == true){
			ItemFound += 1;
			if(ItemFound == 1) strItemOne = item.name;
			if(ItemFound == 2) strItemTwo = item.name;
			if(ItemFound == 3) strItemThree = item.name;
			if(ItemFound == 4) strItemFour = item.name;
			if(ItemFound == 5) strItemFive = item.name;
			if(ItemFound == 6) strItemSix = item.name;
			if(ItemFound == 7) strItemSeven = item.name;
			if(ItemFound == 8) strItemEight = item.name;
			if(ItemFound == 8) break;
		}
		item = item.next();
	}
	if(fileexists(getdir("Temp")+"\\lwoctane_settings.txt")){
		readFile = File( getdir("Temp")+"\\lwoctane_settings.txt", "r");
		if(!readFile) {error("Error when reading lwoctane_settings.txt");return 0;}
		if(readFile.isOpen()) {
			tempver = readFile.read();
			if(tempver == VersionNumber){
				OctaneExePath = readFile.read().asStr();
				PresetSamples = readFile.read().asInt();
				AnimOutputPath = readFile.read().asStr();
				g_GPU = readFile.read().asStr();
				g_SampleCustom = readFile.read().asInt();
				g_OctaneProject = readFile.read().asStr();
				g_Scenename = readFile.read().asStr();
				g_PointOfInt = readFile.read().asNum();
				WriteOBJHow = readFile.read().asNum();
				WriteUVHow = readFile.read().asNum();
				g_UnitSize = readFile.read().asNum();
				g_WriteNORMAL = readFile.read().asNum();
				g_WriteUV = readFile.read().asNum();
			}else{
				readFile.close();
				filedelete(getdir("Temp")+"\\lwoctane_settings.txt");

			}
			readFile.close();
		}

	}else{
		SaveSettings();
	}
	if(AnimOutputPath = "") AnimOutputPath = getdir("Content");
	if(g_OctaneProject = "") g_OctaneProject = getdir("Content");

}
SaveSettings
{
	writeFile = File( getdir("Temp")+"\\lwoctane_settings.txt", "w");
	writeFile.writeln(VersionNumber);
	writeFile.writeln(OctaneExePath);
	writeFile.writeln(PresetSamples);
	writeFile.writeln(AnimOutputPath);
	writeFile.writeln(g_GPU);
	writeFile.writeln(g_SampleCustom);
	writeFile.writeln(g_OctaneProject);
	writeFile.writeln(g_Scenename);
	writeFile.writeln(g_PointOfInt);
	writeFile.writeln(WriteOBJHow);
	writeFile.writeln(WriteUVHow);
	writeFile.writeln(g_UnitSize);
	writeFile.writeln(g_WriteNORMAL);
	writeFile.writeln(g_WriteUV);
	writeFile.close();
}
flags
{

}
ExportOBJJohan
{
	if(UseLog == true){
		Logfile.writeln("Exporting using Johans exporter");
	}

	writeFile = File( getdir("Temp")+"\\lwoctane_exportsettings.txt", "w");
	writeFile.writeln(g_WriteNORMAL.asStr());
	writeFile.writeln(g_WriteUV.asStr());
	writeFile.writeln(WriteUVHow);
	writeFile.writeln(g_Scenename.asStr());
	writeFile.close();

	if(fileexists(getdir("Temp")+"\\octanemerge.obj"))
		filedelete(getdir("Temp")+"\\octanemerge.obj");
	if(fileexists(getdir("Temp")+"\\octanemerge.mtl"))
		filedelete(getdir("Temp")+"\\octanemerge.mtl");
	if(fileexists(getdir("Temp")+"\\octanemergeV.obj"))
		filedelete(getdir("Temp")+"\\octanemergeV.obj");
	if(fileexists(getdir("Temp")+"\\octanemergeNorm.obj"))
		filedelete(getdir("Temp")+"\\octanemergeNorm.obj");
	if(fileexists(getdir("Temp")+"\\octanemergeUV.obj"))
		filedelete(getdir("Temp")+"\\octanemergeUV.obj");




	if(g_SelectedCamera == "" && g_CameraBool == 1){
		info("Select a camera!");
		return;
	}
	if(Mesh("temp_AimNull")){
		info("Please delete null temp_AimNull");
		return;
	}

	mkdir(getdir("Temp") + "\\objects_temp");
	//cleanup
	path1 = matchfiles(getdir("Temp") + "\\objects_temp\\", "*.*");
	if(path1) {
		for(j=1;j<=path1.size();j++){
			filedelete(getdir("Temp") + "\\objects_temp\\" + path1[j]);
		}
	}
	//cleanup
	mkdir(getdir("Temp") + "\\objects_tempOBJ");
	path1 = matchfiles(getdir("Temp") + "\\objects_tempOBJ\\", "*.*");
	if(path1) {
		for(j=1;j<=path1.size();j++){
			filedelete(getdir("Temp") + "\\objects_tempOBJ\\" + path1[j]);
		}
	}

	// multiplier
	Multiplier = 1;
	if(g_UnitSize == 1) Multiplier = 0.001;
	if(g_UnitSize == 2) Multiplier = 0.01;
	if(g_UnitSize == 3) Multiplier = 0.1;
	if(g_UnitSize == 5) Multiplier = 10;
	if(g_UnitSize == 6) Multiplier = 100;
	if(g_UnitSize == 7) Multiplier = 1000;
	if(g_UnitSize == 8) Multiplier = 0.0254;
	if(g_UnitSize == 9) Multiplier = 0.3048;
	if(g_UnitSize == 10) Multiplier = 0.09144;
	if(g_UnitSize == 11) Multiplier = 201.168;
	if(g_UnitSize == 12) Multiplier = 1609.344;



	str = "Generic_OctaneExportOBJ";
	CommandInput(str);



}
ExportOBJLightwave
{
	mkdir(getdir("Temp") + "\\objects_temp");
	//cleanup
	path1 = matchfiles(getdir("Temp") + "\\objects_temp\\", "*.*");
	if(path1) {
		for(j=1;j<=path1.size();j++){
			filedelete(getdir("Temp") + "\\objects_temp\\" + path1[j]);
		}
	}
	//cleanup
	mkdir(getdir("Temp") + "\\objects_tempOBJ");
	path1 = matchfiles(getdir("Temp") + "\\objects_tempOBJ\\", "*.*");
	if(path1) {
		for(j=1;j<=path1.size();j++){
			filedelete(getdir("Temp") + "\\objects_tempOBJ\\" + path1[j]);
		}
	}


	cam = Camera();
	MyCam;
	while(cam){
		if(cam.asStr() == g_SelectedCamera.asStr()){
			MyCam = cam;
		}
		cam = cam.next();
	}
	if(g_SelectedCamera == "" && g_CameraBool == 1){
		info("Select a camera!");
		return;
	}
	if(Mesh("temp_AimNull")){
		info("Please delete null temp_AimNull");
		return;
	}

	// multiplier
	Multiplier = 1;
	if(g_UnitSize == 1) Multiplier = 0.001;
	if(g_UnitSize == 2) Multiplier = 0.01;
	if(g_UnitSize == 3) Multiplier = 0.1;
	if(g_UnitSize == 5) Multiplier = 10;
	if(g_UnitSize == 6) Multiplier = 100;
	if(g_UnitSize == 7) Multiplier = 1000;
	if(g_UnitSize == 8) Multiplier = 0.0254;
	if(g_UnitSize == 9) Multiplier = 0.3048;
	if(g_UnitSize == 10) Multiplier = 0.09144;
	if(g_UnitSize == 11) Multiplier = 201.168;
	if(g_UnitSize == 12) Multiplier = 1609.344;
	if(UseLog == true){
		Logfile.writeln("Writing objectlist");
	}
	//write list

	writeFile = File( getdir("Temp")+"\\lwoctane_objectlist.txt", "w");
	mesh = Mesh();
	while(mesh){
		SelectItem(mesh.id);
		if(mesh.null == false){
			str = string("SaveMotion ",getdir("Temp"),"\\objects_temp\\",mesh.name,".mot");
			CommandInput(str);
			writeFile.writeln(mesh.filename);
			if(UseLog == true){
				Logfile.writeln("Got " + mesh.filename.asStr());
			}
		}
		mesh = mesh.next();
	}
	writeFile.close();
	if(UseLog == true){
		Logfile.writeln("Saving trans");
	}
	//save trans
	mesh = Mesh();
	while(mesh){
		SelectItem(mesh.id);
		if(mesh.null == false){
			Scale(Multiplier,Multiplier,Multiplier);
			str = string("SaveTransformed ",getdir("Temp"),"\\objects_temp\\",mesh.name,".lwo");
			CommandInput(str);
			Scale(1,1,1);
		}
		mesh = mesh.next();
	}

	// replace with trans
	if(UseLog == true){
		Logfile.writeln("Replace with trans");
	}
	mesh = Mesh();
	while(mesh){
		SelectItem(mesh.id);
		if(mesh.null == false){
			filepath = getdir("Temp") + "\\objects_temp\\" + mesh.name + ".lwo";
			if(fileexists(filepath)){
				ReplaceWithObject(filepath);
				if(UseLog == true){
					Logfile.writeln("File is replaced with " + filepath.asStr());
				}
			}else{
				if(UseLog == true){
					Logfile.writeln("File not found! " + filepath.asStr());
				}
			}
			Position(0,0,0);
			Rotation(0,0,0);
		}
		mesh = mesh.next();
	}
	if(UseLog == true){
		Logfile.writeln("Save the OBJ");
	}
	// save obj
	mesh = Mesh();
	while(mesh){
		SelectItem(mesh.id);
		if(mesh.null == false){
			filepath = getdir("Temp") + "\\objects_tempOBJ\\" + mesh.name + ".obj";
			str = string("SaveWavefrontObj ",strright(hex(Mesh(mesh.id).id),8).asStr()," ",filepath);
			//str = "ModCommand_ExportOBJ";
			CommandInput(str);
			sleep(10);
			if(UseLog == true){
				Logfile.writeln("CMD: " + str.asStr());
			}
		}
		mesh = mesh.next();
	}

	if(UseLog == true){
		Logfile.writeln("Merging MTL");
	}
	// save common mtl file
	path1 = matchfiles(getdir("Temp") + "\\objects_tempOBJ\\", "*.mtl");
	writeFile = File(getdir("Temp") + "\\octanemerge.mtl", "w");
	if(path1) {
		for(j=1;j<=path1.size();j++){
			OBJpath = getdir("Temp") + "\\objects_tempOBJ\\" + path1[j];
			if(UseLog == true){
				Logfile.writeln("Got " + OBJpath.asStr());
			}
			if(fileexists(OBJpath) && path1[j] != null)
			{
				readFile = File( OBJpath, "r");
				if(!readFile) {error("Error when reading obj");return 0;}
				if(readFile.isOpen()) {
					while(!readFile.eof())
					{
						line = readFile.read();
						writeFile.writeln(line);
					}
					readFile.close();
				}
			}
			break;
		}
	}
	writeFile.close();
	// merge obj
	if(UseLog == true){
		Logfile.writeln("Merging OBJ");
	}
	path1 = matchfiles(getdir("Temp") + "\\objects_tempOBJ\\", "*.obj");
	writeFile = File(getdir("Temp") + "\\octanemerge.obj", "w");
	totalpoints = 0;
	writeFile.writeln("o " + g_Scenename.asStr() + ".obj");
	writeFile.writeln("mtllib " + g_Scenename.asStr() + ".mtl");
	if(path1) {
		for(j=1;j<=path1.size();j++){
			OBJpath = getdir("Temp") + "\\objects_tempOBJ\\" + path1[j];
			if(UseLog == true){
				Logfile.writeln("Got " + OBJpath.asStr());
			}
			if(fileexists(OBJpath) && path1[j] != null)
			{
				if(UseLog == true)
					Logfile.writeln("Writing...");
				itemname = strleft(path1[j],size(path1[j]) - 4);
				if(UseLog == true)
					Logfile.writeln("itemname: " + itemname.asStr());
				item = Mesh(itemname);
				if(item != null)
				{
					readFile = File( OBJpath, "r");
					if(!readFile) {error("Error when reading obj");return 0;}
					if(readFile.isOpen()) {
						while(!readFile.eof())
						{

							line = readFile.read();
							goon = true;
							if(strleft(line,2) == "o ")
							{
								goon = false;
							}
							if(strleft(line,2) == "g ")
							{
								goon = false;
							}
							if(strleft(line,6) == "mtllib")
							{
								goon = false;
							}
							if(goon == true)
							{
								if(totalpoints == 0){
									writeFile.writeln(line);
								}else{
									if(strleft(line,1) == "f")
									{
										linepars = parse(" ",line);
										lineparstwo = parse("//",linepars[2]);
										lineparsthree = parse("//",linepars[3]);
										lineparsfour = parse("//",linepars[4]);
										if(linepars.size() > 4)
											lineparsfive = parse("//",linepars[5]);
										pointone = lineparstwo[1];
										pointtwo = lineparsthree[1];
										pointthree = lineparsfour[1];
										if(linepars.size() > 4)
											pointfour = lineparsfive[1];
										//writeFile.writeln(line);
										if(linepars.size() > 4)
											writeFile.writeln("f " + (pointone.asInt() + totalpoints.asInt() ) + "// "+ (pointtwo.asInt() + totalpoints.asInt() ) + "// " + (pointthree.asInt() + totalpoints.asInt() ) + "// " + (pointfour.asInt() + totalpoints.asInt() ) + "//");
										else
											writeFile.writeln("f " + (pointone.asInt() + totalpoints.asInt() ) + "// "+ (pointtwo.asInt() + totalpoints.asInt() ) + "// " + (pointthree.asInt() + totalpoints.asInt() ) + "//");
									}else{
									writeFile.writeln(line);
									}
								}
							}
						}
						readFile.close();
					}
					totalpoints += item.pointCount();
				}else{
					info("FYI problems loading model " + itemname);
				}
			}
		}
	}
	writeFile.close();
	if(UseLog == true)
		Logfile.writeln("Replacing with old model");
	// read the list and replace
	if(fileexists(getdir("Temp")+"\\lwoctane_objectlist.txt")){
		readFile = File( getdir("Temp")+"\\lwoctane_objectlist.txt", "r");
		if(!readFile) {error("Error when reading lwoctane_objectlist.txt");return 0;}
		if(readFile.isOpen()) {
			mesh = Mesh();
			while(!readFile.eof())
			{
				if(mesh.null == false){
					SelectItem(mesh.id);

					filepath = readFile.read();
					if(UseLog == true)
						Logfile.writeln("filepath: " + filepath.asStr());
					if(fileexists(filepath))
						ReplaceWithObject(filepath);
					str = string("LoadMotion ",getdir("Temp"),"\\objects_temp\\",mesh.name,".mot");
					CommandInput(str);
				}
				mesh = mesh.next();
			}
			readFile.close();
		}
	}



}


Render_Button
{
	if (Scene().generalopts[7]==0) {
		AutoKey();
	}
	// multiplier
	Multiplier = 1;
	if(g_UnitSize == 1) Multiplier = 0.001;
	if(g_UnitSize == 2) Multiplier = 0.01;
	if(g_UnitSize == 3) Multiplier = 0.1;
	if(g_UnitSize == 5) Multiplier = 10;
	if(g_UnitSize == 6) Multiplier = 100;
	if(g_UnitSize == 7) Multiplier = 1000;
	if(g_UnitSize == 8) Multiplier = 0.0254;
	if(g_UnitSize == 9) Multiplier = 0.3048;
	if(g_UnitSize == 10) Multiplier = 0.09144;
	if(g_UnitSize == 11) Multiplier = 201.168;
	if(g_UnitSize == 12) Multiplier = 1609.344;

	SaveSettings();
	if(UseLog == true){
		Logfile.writeln("Render button pressed");
		Logfile.writeln("Unitsize is " + g_UnitSize.asStr());
	}


	//if(WriteOBJHow == 2)
	//	ExportOBJJohan();
	//else if(WriteOBJHow == 1)
	//	ExportOBJLightwave();
	//else
	//	return;

	// copy file to our place
	if(UseLog == true){
		Logfile.writeln("Check if written obj is in temp:");
		Logfile.writeln((getdir("Temp") + "\\octanemerge.obj"));
		if(!fileexists(getdir("Temp")+"\\octanemerge.obj"))
			Logfile.writeln("File is not there");
		else
			Logfile.writeln("File is there");
	}
	if(fileexists(getdir("Temp")+"\\octanemerge.obj")){
		code = filecopy(getdir("Temp")+"\\octanemerge.obj",g_OctaneProject + "\\" + g_Scenename + ".obj");
		if(code == -1) {
			info("Failed to copy obj");
		}
	}
	if(fileexists(getdir("Temp")+"\\octanemerge.mtl")){
		code = filecopy(getdir("Temp")+"\\octanemerge.mtl",g_OctaneProject + "\\" + g_Scenename + ".mtl");
		if(code == -1) {
			info("Failed to copy mtl");
		}
	}



	//cleanup
	path1 = matchfiles(getdir("Temp") + "\\objects_temp\\", "*.*");
	if(path1) {
		for(j=1;j<=path1.size();j++){
			filedelete(getdir("Temp") + "\\objects_temp\\" + path1[j]);
		}
	}

	LaunchOctane(false);
    requpdate();
}

ExportLWOFrame_Button
{
	mkdir(getdir("Temp") + "\\objects_temp");
	//cleanup
	path1 = matchfiles(getdir("Temp") + "\\objects_temp\\", "*.*");
	if(path1) {
		for(j=1;j<=path1.size();j++){
			filedelete(getdir("Temp") + "\\objects_temp\\" + path1[j]);
		}
	}
	//cleanup
	mkdir(getdir("Temp") + "\\objects_tempOBJ");
	path1 = matchfiles(getdir("Temp") + "\\objects_tempOBJ\\", "*.*");
	if(path1) {
		for(j=1;j<=path1.size();j++){
			filedelete(getdir("Temp") + "\\objects_tempOBJ\\" + path1[j]);
		}
	}
	tempobj = (getdir("Temp") + "\\octanemerge.obj");
	if(fileexists(tempobj))
		filedelete(tempobj);
	tempobj = (getdir("Temp") + "\\octanemerge.mtl");
	if(fileexists(tempobj))
		filedelete(tempobj);
		
	// multiplier
	Multiplier = 1;
	if(g_UnitSize == 1) Multiplier = 0.001;
	if(g_UnitSize == 2) Multiplier = 0.01;
	if(g_UnitSize == 3) Multiplier = 0.1;
	if(g_UnitSize == 5) Multiplier = 10;
	if(g_UnitSize == 6) Multiplier = 100;
	if(g_UnitSize == 7) Multiplier = 1000;
	if(g_UnitSize == 8) Multiplier = 0.0254;
	if(g_UnitSize == 9) Multiplier = 0.3048;
	if(g_UnitSize == 10) Multiplier = 0.09144;
	if(g_UnitSize == 11) Multiplier = 201.168;
	if(g_UnitSize == 12) Multiplier = 1609.344;
	if(UseLog == true){
		Logfile.writeln("Writing objectlist");
	}
	//write list

	writeFile = File( getdir("Temp")+"\\lwoctane_objectlist.txt", "w");
	mesh = Mesh();
	while(mesh){
		SelectItem(mesh.id);
		if(mesh.null == false){
			str = string("SaveMotion ",getdir("Temp"),"\\objects_temp\\",mesh.name,".mot");
			CommandInput(str);
			writeFile.writeln(mesh.filename);
			if(UseLog == true){
				Logfile.writeln("Got " + mesh.filename.asStr());
			}
		}
		mesh = mesh.next();
	}
	writeFile.close();
	if(UseLog == true){
		Logfile.writeln("Saving trans");
	}
	//save trans
	mesh = Mesh();
	while(mesh){
		SelectItem(mesh.id);
		if(mesh.null == false){
			//Scale(Multiplier,Multiplier,Multiplier);
			str = string("SaveTransformed ",getdir("Temp"),"\\objects_temp\\",mesh.name,".lwo");
			CommandInput(str);
			Scale(1,1,1);
		}
		mesh = mesh.next();
	}
	info("Done");
}

ExportLWOTimeline_Button
{
}

LaunchOctane: AnimationMode
{
	if(UseLog == true)
		Logfile.writeln("Launching Octane");

	POIObject;
	item = Mesh();
	while(item){
		if(g_SelectedItem != null){
			if(Mesh(g_SelectedItem.name)){
				if(item.name.asStr() == g_SelectedItem.name.asStr()){
					POIObject = item;
					if(UseLog == true)
						Logfile.writeln("POI: " + POIObject.name.asStr());
					break;
				}
			}
		}
		item = item.next();
	}


	cam = Camera();
	while(cam){
		if(g_SelectedCamera != null){
			if(Camera(g_SelectedCamera.name)){
				if(cam.name.asStr() == g_SelectedCamera.name.asStr()){
					MyCam = cam;
					if(UseLog == true)
						Logfile.writeln("MyCam: " + MyCam.name.asStr());
					break;
				}
			}
		}
		cam = cam.next();
	}
	MyLight;
	lght = Light();
	while(lght){
		SelectItem(lght.name);
		if(g_SelectedLight != null){
			if(Light(g_SelectedLight.name)){
				if(lght.name.asStr() == g_SelectedLight.name.asStr())
					MyLight = lght;
			}
		}
		lght = lght.next();
	}
	// create the aim
	AddNull("temp_AimNull");
	if (Scene().generalopts[3]==1) {
		ParentInPlace();
	}

	ParentItem(MyCam.name);
	if(POIObject){
		dist = vmag(extent(POIObject.getWorldPosition(Scene().currenttime),MyCam.getWorldPosition(Scene().currenttime)));
		if(UseLog == true)
			Logfile.writeln("dist: " + dist.asStr());
		AddPosition(0.000000,0.000000,dist.asNum());
	}else{
		AddPosition(0.000000,0.000000,g_PointOfInt.asNum());
	}

	SelectItem("temp_AimNull");
	selected=Scene().getSelect();
	RefreshNow();
	AimposX = (Mesh(selected[1].id).getWorldPosition(Scene().currenttime).x) * Multiplier;
	AimposY = (Mesh(selected[1].id).getWorldPosition(Scene().currenttime).y) * Multiplier;
	AimposZ = (Mesh(selected[1].id).getWorldPosition(Scene().currenttime).z * -1) * Multiplier;
	if(UseLog == true){
		Logfile.writeln("AimposX: " + AimposX.asStr());
		Logfile.writeln("AimposY: " + AimposY.asStr());
		Logfile.writeln("AimposZ: " + AimposZ.asStr());
	}
	if(m_InterpolateMode == 1){
		AimposXmotion = (Mesh(selected[1].id).getWorldPosition(Scene().currenttime + (1 / Scene().fps)).x) * Multiplier;
		AimposYmotion = (Mesh(selected[1].id).getWorldPosition(Scene().currenttime + (1 / Scene().fps)).y) * Multiplier;
		AimposZmotion = (Mesh(selected[1].id).getWorldPosition(Scene().currenttime + (1 / Scene().fps)).z * -1) * Multiplier;
	}else{
		AimposXmotion = (Mesh(selected[1].id).getWorldPosition(Scene().currenttime - (1 / Scene().fps)).x) * Multiplier;
		AimposYmotion = (Mesh(selected[1].id).getWorldPosition(Scene().currenttime - (1 / Scene().fps)).y) * Multiplier;
		AimposZmotion = (Mesh(selected[1].id).getWorldPosition(Scene().currenttime - (1 / Scene().fps)).z * -1) * Multiplier;
	}
	//AimposXmotion = (Mesh(selected[1].id).getWorldPosition(Scene().currenttime).x) * Multiplier;
	//AimposYmotion = (Mesh(selected[1].id).getWorldPosition(Scene().currenttime).y) * Multiplier;
	//AimposZmotion = (Mesh(selected[1].id).getWorldPosition(Scene().currenttime).z * -1) * Multiplier;
	AutoConfirm(1);
	ClearSelected();
	AutoConfirm(0);

	SunSpotStr = "";
	// are we using sunspot?
	if(MyLight){
		lightx = (MyLight.getWorldPosition(Scene().currenttime).x) * Multiplier;
		lighty = (MyLight.getWorldPosition(Scene().currenttime).y) * Multiplier;
		lightz = (MyLight.getWorldPosition(Scene().currenttime).z * -1) * Multiplier;
		SunSpotStr = " --daylight-sundir-x " + lightx.asStr() + " --daylight-sundir-y " + lighty + " --daylight-sundir-z " + lightz + " ";
	}
	// launch octane
	samples = g_SampleCustom;

	spawncmd;
	if(AnimationMode == false){
		if(!fileexists(g_OctaneProject + "\\" + g_Scenename + ".ocs"))
			spawncmd = " -n \"" +g_OctaneProject + "\\" + g_Scenename + ".ocs\" -m " + g_Scenename + ".obj -l \"" + g_OctaneProject + "\\" + g_Scenename + ".obj\" -s " + samples.asStr();
		else
			spawncmd = " -m " + g_Scenename + ".obj -r \"" + g_OctaneProject + "\\" + g_Scenename + ".obj\"";
	}else{
		time = Scene().currenttime * Scene().fps;
		spawncmd = " -e -q -o \"" + AnimOutputPath.asStr() + "\\" + g_Scenename.asStr() + time.asStr() + ".png\" -s " + samples.asStr() + " -m " + g_Scenename.asStr() + ".obj -r \"" + g_OctaneProject + "\\" + g_Scenename + "_anim.obj\"";
	}
	if(g_CameraBool == 1)
	{

		camx = (MyCam.getWorldPosition(Scene().currenttime).x) * Multiplier;
		camy = (MyCam.getWorldPosition(Scene().currenttime).y) * Multiplier;
		camz = (MyCam.getWorldPosition(Scene().currenttime).z * -1) * Multiplier;
		camAperture = " --cam-aperture " + g_Aperture;
		fov = MyCam.fovAngles(0);
		camFov = " --cam-fov " + deg(fov[1]).asStr();
		spawncmd += " --cam-pos-x " + camx.asStr() + " --cam-pos-y " + camy.asStr() + " --cam-pos-z " + camz.asStr() + " --cam-target-x " + AimposX.asStr() + " --cam-target-y " + AimposY.asStr() + " --cam-target-z " + AimposZ.asStr();
		spawncmd += camAperture.asStr() + camFov.asStr();
		if(UseLog == true){
			Logfile.writeln("Writing cam position " + MyCam.name.asStr());
			Logfile.writeln("camx:" + camx.asStr());
			Logfile.writeln("camy:" + camy.asStr());
			Logfile.writeln("camz:" + camz.asStr());
		}
	}
	if(g_CameraBool == 1 && g_CheckFocal == 1 )
	{
		spawncmd += " --cam-focaldepth " + g_FocalDepth.asStr();
	}
	if(g_ResolutionBool == 1)
	{
		spawncmd += " --film-width " + g_ResWidth.asStr() + " --film-height " + g_ResHeight.asStr();
	}
	if(g_ExportSunDir == 1)
	{
		spawncmd += SunSpotStr.asStr();
	}
	if(m_MotionBlur == 1)
	{
		if(m_InterpolateMode == 1){
			motionx = MyCam.getWorldPosition(Scene().currenttime + (1 / Scene().fps)).x * Multiplier;
			motiony = MyCam.getWorldPosition(Scene().currenttime + (1 / Scene().fps)).y * Multiplier;
			motionz = (MyCam.getWorldPosition(Scene().currenttime + (1 / Scene().fps)).z * -1) * Multiplier;
		}else{
			motionx = MyCam.getWorldPosition(Scene().currenttime + (1 / Scene().fps)).x * Multiplier;
			motiony = MyCam.getWorldPosition(Scene().currenttime + (1 / Scene().fps)).y * Multiplier;
			motionz = (MyCam.getWorldPosition(Scene().currenttime + (1 / Scene().fps)).z * -1) * Multiplier;
		}
		//motionx = MyCam.getWorldPosition(Scene().currenttime).x * Multiplier;
		//motiony = MyCam.getWorldPosition(Scene().currenttime).y * Multiplier;
		//motionz = (MyCam.getWorldPosition(Scene().currenttime).z * -1) * Multiplier;
		spawncmd += " --cam-motion-pos-x " + motionx.asStr() + " --cam-motion-pos-y " + motiony.asStr() + " --cam-motion-pos-z " + motionz.asStr();


		spawncmd += " --cam-motion-target-x " + AimposXmotion.asStr() + " --cam-motion-target-y " + AimposYmotion.asStr() + " --cam-motion-target-z " + AimposZmotion.asStr();

	}

	if(g_CheckGPU == 1){
		gpupars = parse(" ",g_GPU.asStr());
		for(i = 1; i <= gpupars.size(); i++){
			gpu = gpupars[i];
			spawncmd += " -g " + gpu.asStr();
		}
	}
	if(AnimationMode == true)
	{
		if(fileexists(g_OctaneProject + "\\" + g_Scenename + ".ocs"))
			spawncmd += " \"" +g_OctaneProject + "\\" + g_Scenename + ".ocs\"";
		writeFile = File( getdir("Temp")+"\\lwoctane_launch.txt", "w");
		writeFile.writeln(spawncmd);
		writeFile.writeln(OctaneExePath);
		writeFile.close();
		str = "Generic_LaunchOctane";
		CommandInput(str);
	}else{
		if(fileexists(g_OctaneProject + "\\" + g_Scenename + ".ocs"))
			spawncmd += " \"" +g_OctaneProject + "\\" + g_Scenename + ".ocs\"";
		if(UseLog == true)
			Logfile.writeln(spawncmd.asStr());


		snID = spawn(OctaneExePath.asStr() + spawncmd.asStr());
	}

}
ctl_octaneproject;
ctl_projectname;
options
{
    if(reqisopen())
        reqend();
    else
    {
		ItemFound = 0;
		item = Mesh();
		while(item){
			if(item.null == true){
				ItemFound += 1;
				if(ItemFound == 1) strItemOne = item.name;
				if(ItemFound == 2) strItemTwo = item.name;
				if(ItemFound == 3) strItemThree = item.name;
				if(ItemFound == 4) strItemFour = item.name;
				if(ItemFound == 5) strItemFive = item.name;
				if(ItemFound == 6) strItemSix = item.name;
				if(ItemFound == 7) strItemSeven = item.name;
				if(ItemFound == 8) strItemEight = item.name;
				if(ItemFound == 8) break;
			}
			item = item.next();
		}

        reqbegin("Octane Exporter");
        reqsize(WIDTH,HEIGHT);
		c1 = ctlimage("C:/LWSDK/sample/Layout/Generic/OctaneExport2/lw.tga",1,1,,350,62);
		
		ctl_tabs = ctltab("Octane","Lightwave Exporter Settings");
		ctlposition(ctl_tabs,1,65);

		ctl_octane = ctlfilename("Octane Render Binary",OctaneExePath,WIDTH - 30,1);
		ctlposition(ctl_octane,5,ctl_tabs.y + 20,WIDTH - 34);
		ctlrefresh(ctl_octane,"ctl_octane_change");

		ctl_octaneproject = ctlfoldername("Project Path",g_OctaneProject);
		ctlposition(ctl_octaneproject,5,ctl_octane.y + 20,WIDTH - 34,19);
		ctlrefresh(ctl_octaneproject,"ctl_octaneproject_change");

		ctl_projectname = ctlstring("Project Name",g_Scenename);
		ctlposition(ctl_projectname,5,ctl_octaneproject.y + 20,230);
		ctlrefresh(ctl_projectname,"ctl_projectname_change");

		ctl_UseProjButton = ctlbutton("Use existing project",100,"UseProjectButton");
		ctlposition(ctl_UseProjButton,244,ctl_octaneproject.y + 20);

		ctl_unitsize = ctlpopup("Native Unit Size",g_UnitSize,@"Millimeters","Centimeters","Decimeters","Meters","Hectometers","Kilometers","Inches","Feet","Yards","Furlongs","Miles"@);
		ctlposition(ctl_unitsize,5,ctl_projectname.y + 20,WIDTH - 11);
		ctlrefresh(ctl_unitsize,"ctl_unitsize_change");

		ctl_ResEnable = ctlcheckbox("Resolution",g_ResolutionBool);
		ctlposition(ctl_ResEnable,5,ctl_unitsize.y + 40);
		ctlrefresh(ctl_ResEnable,"ctl_ResEnable_change");

		ctl_reswidth = ctlminislider("Width",g_ResWidth,1,8000);
		ctlposition(ctl_reswidth,90,ctl_ResEnable.y,70);
		ctlrefresh(ctl_reswidth,"ctl_reswidth_change");


		ctl_resheight = ctlminislider("Height",g_ResHeight,1,8000);
		ctlposition(ctl_resheight,184,ctl_ResEnable.y,70);
		ctlrefresh(ctl_resheight,"ctl_resheight_change");

		ctl_scaleres = ctlpopup("",g_ScaleRes,@"100%","75%","50%","25%"@);
		ctlposition(ctl_scaleres,286,ctl_ResEnable.y,58);
		ctlrefresh(ctl_scaleres,"ctl_scaleres_change");

		ctl_ExportCameraCheck = ctlcheckbox("Export Camera",g_CameraBool);
		ctlposition(ctl_ExportCameraCheck,5,ctl_ResEnable.y + 20);
		ctlrefresh(ctl_ExportCameraCheck,"ctl_ExportCameraCheck_change");

		ctl_CameraDropDown = ctlcameraitems("Active Camera",g_SelectedCamera);
		ctlposition(ctl_CameraDropDown,150,ctl_ResEnable.y + 20,194);
		ctlrefresh(ctl_CameraDropDown,"ctl_cameraname_change");


		ctl_pointofint = ctlnumber("Point Of Interest",g_PointOfInt);
		ctlposition(ctl_pointofint,5,ctl_CameraDropDown.y + 20,130);
		ctlrefresh(ctl_pointofint,"ctl_pointofint_change");

		/*if(ItemFound == 0) ctl_Itemname = ctlpopup("POI Item",g_SelectedItem,@"None"@);
		if(ItemFound == 1) ctl_Itemname = ctlpopup("POI Item",g_SelectedItem,@"None",strItemOne@);
		if(ItemFound == 2) ctl_Itemname = ctlpopup("POI Item",g_SelectedItem,@"None",strItemOne,strItemTwo@);
		if(ItemFound == 3) ctl_Itemname = ctlpopup("POI Item",g_SelectedItem,@"None",strItemOne,strItemTwo,strItemThree@);
		if(ItemFound == 4) ctl_Itemname = ctlpopup("POI Item",g_SelectedItem,@"None",strItemOne,strItemTwo,strItemThree,strItemFour@);
		if(ItemFound == 5) ctl_Itemname = ctlpopup("POI Item",g_SelectedItem,@"None",strItemOne,strItemTwo,strItemThree,strItemFour,strItemFive@);
		if(ItemFound == 6) ctl_Itemname = ctlpopup("POI Item",g_SelectedItem,@"None",strItemOne,strItemTwo,strItemThree,strItemFour,strItemFive,strItemSix@);
		if(ItemFound == 7) ctl_Itemname = ctlpopup("POI Item",g_SelectedItem,@"None",strItemOne,strItemTwo,strItemThree,strItemFour,strItemFive,strItemSix,strItemSeven@);
		if(ItemFound == 8) ctl_Itemname = ctlpopup("POI Item",g_SelectedItem,@"None",strItemOne,strItemTwo,strItemThree,strItemFour,strItemFive,strItemSix,strItemSeven,strItemEight@);*/
		ctl_Itemname = ctlallitems("POI Item",g_SelectedItem);
		ctlposition(ctl_Itemname,150,ctl_CameraDropDown.y + 20,194);
		ctlrefresh(ctl_Itemname,"ctl_Itemname_change");




		ctl_CheckAperture = ctlcheckbox("Lens Aperture Radius (cm)",g_CheckAperture);
		ctlposition(ctl_CheckAperture,5,ctl_Itemname.y + 20);
		ctlrefresh(ctl_CheckAperture,"ctl_CheckAperture_change");

		ctl_aperture = ctlnumber("",g_Aperture);
		ctlposition(ctl_aperture,200,ctl_Itemname.y + 20,142);
		ctlrefresh(ctl_aperture,"ctl_aperture_change");

		ctl_CheckFocal = ctlcheckbox("Focal Depth (m)",g_CheckFocal);
		ctlposition(ctl_CheckFocal,5,ctl_aperture.y + 20);
		ctlrefresh(ctl_CheckFocal,"ctl_CheckFocal_change");

		ctl_focaldepth = ctlnumber("",g_FocalDepth);
		ctlposition(ctl_focaldepth,200,ctl_CheckAperture.y + 20,142);
		ctlrefresh(ctl_focaldepth,"ctl_focaldepth_change");

		ctl_MotionBlurCheck = ctlcheckbox("Motion Blur",m_MotionBlur);
		ctlposition(ctl_MotionBlurCheck,5,ctl_CheckFocal.y + 20);
		ctlrefresh(ctl_MotionBlurCheck,"ctl_MotionBlurCheck_change");

		ctl_interpolate = ctlpopup("Interpolate",m_InterpolateMode,@"Next","Previous"@);
		ctlposition(ctl_interpolate,150,ctl_CheckFocal.y + 20,194);
		ctlrefresh(ctl_interpolate,"ctl_interpolate_change");

		ctl_ExportSunDir = ctlcheckbox("Export Sun Direction",g_ExportSunDir);
		ctlposition(ctl_ExportSunDir,5,ctl_MotionBlurCheck.y + 20);
		ctlrefresh(ctl_ExportSunDir,"ctl_ExportSunDir_change");

		ctl_lightname = ctllightitems("LightItems",g_SelectedLight);
		ctlposition(ctl_lightname,150,ctl_MotionBlurCheck.y + 20,194);
		ctlrefresh(ctl_lightname,"ctl_lightname_change");


		ctl_GPUCheck = ctlcheckbox("Specify GPU Devices to use",g_CheckGPU);
		ctlposition(ctl_GPUCheck,5,ctl_lightname.y + 20);
		ctlrefresh(ctl_GPUCheck,"ctl_GPUCheck_change");

		ctl_GPU = ctlstring("",g_GPU);
		ctlposition(ctl_GPU,200,ctl_GPUCheck.y,142);
		ctlrefresh(ctl_GPU,"ctl_GPU_change");


        //ctl_ExportButton      	= ctlbutton("Export Obj/MTL only",110,"ExportOBJ_Button");
		//ctlposition(ctl_ExportButton,10,ctl_GPU.y + 30,110,25);
		
        ctl_ExportButton      	= ctlbutton("Prepare Current Frame",110,"ExportLWOFrame_Button");
		ctlposition(ctl_ExportButton,10,ctl_GPU.y + 30,130,25);

		//ctl_RenderButton        = ctlbutton("Prepare Timeline",45,"ExportLWOTimeline_Button");
		//ctlposition(ctl_RenderButton,ctl_ExportButton.x + ctl_ExportButton.w + 84,ctl_ExportButton.y,100,25);
		
		//ctl_RenderButton        = ctlbutton("Render",45,"Render_Button");
		//ctlposition(ctl_RenderButton,ctl_ExportButton.x + ctl_ExportButton.w + 84,ctl_ExportButton.y,45,25);
		
		ctl_RenderButton        = ctlbutton("Render",45,"Render_Button");
		ctlposition(ctl_RenderButton,ctl_ExportButton.x + ctl_ExportButton.w + 84,ctl_ExportButton.y + 30,45,25);
		
		ctl_selectfolder = ctlfoldername("Image Output",AnimOutputPath);
		ctlposition(ctl_selectfolder,5,ctl_RenderButton.y + 30,WIDTH - 34,19);
		ctlrefresh(ctl_selectfolder,"ctl_selectfolder_change");

		ctl_startframe = ctlinteger("Start Frame",startFrame);
		ctlposition(ctl_startframe,5,ctl_selectfolder.y + 20,100);
		ctlrefresh(ctl_startframe,"ctl_startframe_change");

		ctl_endframe = ctlinteger("End Frame",endFrame);
		ctlposition(ctl_endframe,120,ctl_selectfolder.y + 20,100);
		ctlrefresh(ctl_endframe,"ctl_endframe_change");

		ctl_stepframe = ctlinteger("Step",stepFrame);
		ctlposition(ctl_stepframe,240,ctl_selectfolder.y + 20,85);
		ctlrefresh(ctl_stepframe,"ctl_stepframe_change");


		ctl_customsamples = ctlinteger("Pixelsamples",g_SampleCustom);
		ctlposition(ctl_customsamples,5,ctl_startframe.y + 20,105);
		ctlrefresh(ctl_customsamples,"ctl_samplescustom_change");

		ctl_samplesdropdown = ctlpopup("",PresetSamples,@"Very Low (8 s/px)","Low (32 s/px)","Medium (256 s/px)","Medium/High (512 s/px)","High (1024 s/px)","Very High (4096 s/px)"@);
		ctlposition(ctl_samplesdropdown,ctl_customsamples.x + ctl_customsamples.w + 1,ctl_startframe.y + 20,140);
		ctlrefresh(ctl_samplesdropdown,"ctl_samplesdropdown_change");

		ctl_RenderAnimButton    = ctlbutton("Render Animation",94,"RenderAnim_Button");
		ctlposition(ctl_RenderAnimButton,ctl_samplesdropdown.x + ctl_samplesdropdown.w + 3,ctl_samplesdropdown.y);

		ctlpage(1,ctl_scaleres,ctl_octane,ctl_octaneproject,ctl_projectname,ctl_UseProjButton,ctl_unitsize,ctl_ResEnable,ctl_reswidth,ctl_resheight,ctl_ExportCameraCheck,ctl_CameraDropDown,ctl_pointofint,ctl_Itemname,ctl_CheckAperture,ctl_aperture,ctl_CheckFocal,ctl_focaldepth,ctl_MotionBlurCheck,ctl_interpolate,ctl_ExportSunDir,ctl_lightname,ctl_GPU,ctl_GPUCheck,ctl_RenderAnimButton,ctl_samplesdropdown,ctl_stepframe,ctl_endframe,ctl_startframe,ctl_selectfolder,ctl_ExportButton,ctl_RenderButton);
		ctlpage(1,ctl_customsamples);
		ctl_exportobj = ctlpopup("OBJ Exporter",WriteOBJHow,@"Lightwave OBJ Export (HC only)","Octane OBJ Export (win only)"@);
		ctlposition(ctl_exportobj,5,ctl_tabs.y + 20,332);
		ctlrefresh(ctl_exportobj,"ctl_exportobj_change");

		ctl_readuv = ctlpopup("Octane OBJ Export Proporties",WriteUVHow,@"Normal","Fast"@);
		ctlposition(ctl_readuv,5,ctl_exportobj.y + 20,332);
		ctlrefresh(ctl_readuv,"ctl_readuv_change");


		ctl_WriteUV = ctlcheckbox("Write UV",g_WriteUV);
		ctlposition(ctl_WriteUV,5,ctl_readuv.y + 20);
		ctlrefresh(ctl_WriteUV,"ctl_WriteUV_change");

		ctl_WriteNORMAL = ctlcheckbox("Write Point Normal",g_WriteNORMAL);
		ctlposition(ctl_WriteNORMAL,ctl_WriteUV.x + ctl_WriteUV.w + 10,ctl_WriteUV.y);
		ctlrefresh(ctl_WriteNORMAL,"ctl_WriteNORMAL_change");


		ctl_ForceOBJExport = ctlcheckbox("Force OBJ Export(animation)",g_ForceOBJExport);
		ctlposition(ctl_ForceOBJExport,5,ctl_WriteNORMAL.y + 20);
		ctlrefresh(ctl_ForceOBJExport,"ctl_ForceOBJExport_change");

        ctl_OutputLog      	= ctlbutton("Output Logfile",110,"OutputLog_Button");
		ctlposition(ctl_OutputLog,5,ctl_ForceOBJExport.y + 30);

		ctlpage(2,ctl_exportobj,ctl_WriteNORMAL,ctl_WriteUV,ctl_ForceOBJExport,ctl_readuv,ctl_OutputLog);

        reqopen();
    }
}
OutputLog_Button
{
	Logfilename = getfile("Save logfile","*.txt",getdir("Content"),0);
	if(!Logfilename) return;
	Logfile = File( Logfilename, "w");
	Logfile.writeln("LogFile created");
	UseLog = true;
}

RenderAnim_Button
{
	if (Scene().generalopts[7]==0) {
		AutoKey();
	}
	mkdir(AnimOutputPath.asStr());
	SaveSettings();
	GoToFrame(startFrame);
	RefreshNow();

	NumberOfObjectsInScene = 0;
	item = Mesh();
	while(item)
	{
		if(item.null == false)
			NumberOfObjectsInScene++;
		item = item.next();
	}
	if(NumberOfObjectsInScene == 0) return;
	item = Mesh();
	currentobject = 0;
	SceneExportEveryFrame = false;
	while(item)
	{
		if(g_ForceOBJExport == 1){
			SceneExportEveryFrame = true;
			break;
		}
		if(item.null == false){
			currentobject++;
			ObjectsToReExp[currentobject] = 0;
			time = startFrame / Scene().fps;
			ObjectPos = item.getWorldPosition(time);
			ObjectRot = item.getWorldRotation(time);
			for( i=startFrame; i<=endFrame; i++ ) {
				time = i / Scene().fps;
				if(ObjectPos != item.getWorldPosition(time) || ObjectRot != item.getWorldRotation(time)){
					SceneExportEveryFrame = true;
					break;
				}
			}
		}
		item = item.next();
	}

	for( i=startFrame; i<=endFrame; i++ ) {
		RefreshNow();
		time = i / Scene().fps;

		if(SceneExportEveryFrame == true || i == startFrame){

			oldSceneName = g_Scenename;
			g_Scenename += "_anim";

			if(WriteOBJHow == 2)
				ExportOBJJohan();
			else
				ExportOBJLightwave();

			// copy file to our place
			if(fileexists(getdir("Temp")+"\\octanemerge.obj")){

				code = filecopy(getdir("Temp")+"\\octanemerge.obj",g_OctaneProject + "\\" + g_Scenename + ".obj");
			}
			if(fileexists(getdir("Temp")+"\\octanemerge.mtl")){
				code = filecopy(getdir("Temp")+"\\octanemerge.mtl",g_OctaneProject + "\\" + g_Scenename + ".mtl");
			}

			g_Scenename = oldSceneName;


		}

		LaunchOctane(true);
		if(stepFrame > 1)
			i += stepFrame - 1;
		GoToFrame(i);
		RefreshNow();
	}
	GoToFrame(startFrame);
	//cleanup
	path1 = matchfiles(getdir("Temp") + "\\objects_temp\\", "*.*");
	if(path1) {
		for(j=1;j<=path1.size();j++){
			filedelete(getdir("Temp") + "\\objects_temp\\" + path1[j]);
		}
	}
    requpdate();
}

ExportOBJ_Button
{

	OBJName = getfile("Save .OBJ","*.obj",getdir("Objects"),0);
	if(!OBJName) return;
	writeFile = File( getdir("Temp")+"\\lwoctane_exportsettings.txt", "w");
	writeFile.writeln(g_WriteNORMAL.asStr());
	writeFile.writeln(g_WriteUV.asStr());
	writeFile.writeln(WriteUVHow);
	nameInMaterial = OBJName;
	nameInMaterial = parse("\\",nameInMaterial);
	nameInMaterial = nameInMaterial[nameInMaterial.size()];
	nameInMaterial = strleft(nameInMaterial,nameInMaterial.size() - 4);
	writeFile.writeln(nameInMaterial.asStr());
	writeFile.close();
	if(WriteOBJHow == 2)
	{
		str = "Generic_OctaneExportOBJ";
		CommandInput(str);
		code = filecopy(getdir("Temp")+"\\octanemerge.obj",OBJName);
		if(code == -1) {
			info("Failed to copy obj");
		}
		mtlname = strleft(OBJName,OBJName.size() - 4);
		code = filecopy(getdir("Temp")+"\\octanemerge.mtl",mtlname + ".mtl");
		if(code == -1) {
			info("Failed to copy mtl");
		}
    }else{
		mkdir(getdir("Temp") + "\\objects_temp");
		//cleanup
		path1 = matchfiles(getdir("Temp") + "\\objects_temp\\", "*.*");
		if(path1) {
			for(j=1;j<=path1.size();j++){
				filedelete(getdir("Temp") + "\\objects_temp\\" + path1[j]);
			}
		}
		//cleanup
		mkdir(getdir("Temp") + "\\objects_tempOBJ");
		path1 = matchfiles(getdir("Temp") + "\\objects_tempOBJ\\", "*.*");
		if(path1) {
			for(j=1;j<=path1.size();j++){
				filedelete(getdir("Temp") + "\\objects_tempOBJ\\" + path1[j]);
			}
		}
		// multiplier
		Multiplier = 1;
		if(g_UnitSize == 1) Multiplier = 0.001;
		if(g_UnitSize == 2) Multiplier = 0.01;
		if(g_UnitSize == 3) Multiplier = 0.1;
		if(g_UnitSize == 5) Multiplier = 10;
		if(g_UnitSize == 6) Multiplier = 100;
		if(g_UnitSize == 7) Multiplier = 1000;
		if(g_UnitSize == 8) Multiplier = 0.0254;
		if(g_UnitSize == 9) Multiplier = 0.3048;
		if(g_UnitSize == 10) Multiplier = 0.09144;
		if(g_UnitSize == 11) Multiplier = 201.168;
		if(g_UnitSize == 12) Multiplier = 1609.344;
		//write list
		writeFile = File( getdir("Temp")+"\\lwoctane_objectlist.txt", "w");
		mesh = Mesh();
		while(mesh){
			SelectItem(mesh.id);
			if(mesh.null == false){
				str = string("SaveMotion ",getdir("Temp"),"\\objects_temp\\",mesh.name,".mot");
				CommandInput(str);
				writeFile.writeln(mesh.filename);
			}
			mesh = mesh.next();
		}
		writeFile.close();

		//save trans
		mesh = Mesh();
		while(mesh){
			SelectItem(mesh.id);
			if(mesh.null == false){
				Scale(Multiplier,Multiplier,Multiplier);
				str = string("SaveTransformed ",getdir("Temp"),"\\objects_temp\\",mesh.name,".lwo");
				CommandInput(str);
				Scale(1,1,1);
			}
			mesh = mesh.next();
		}

		// replace with trans

		mesh = Mesh();
		while(mesh){
			SelectItem(mesh.id);
			if(mesh.null == false){
				filepath = getdir("Temp") + "\\objects_temp\\" + mesh.name + ".lwo";
				if(fileexists(filepath))
					ReplaceWithObject(filepath);
				Position(0,0,0);
				Rotation(0,0,0);
			}
			mesh = mesh.next();
		}

		// save obj
		mesh = Mesh();
		while(mesh){
			SelectItem(mesh.id);
			if(mesh.null == false){
				filepath = getdir("Temp") + "\\objects_tempOBJ\\" + mesh.name + ".obj";
				str = string("SaveWavefrontObj ",strright(hex(Mesh(mesh.id).id),8).asStr()," ",filepath);
				//str = "ModCommand_ExportOBJ";
				CommandInput(str);
				sleep(10);
			}
			mesh = mesh.next();
		}

		// save common mtl file
		path1 = matchfiles(getdir("Temp") + "\\objects_tempOBJ\\", "*.mtl");
		writeFile = File(getdir("Temp") + "\\octanemerge.mtl", "w");
		if(path1) {
			for(j=1;j<=path1.size();j++){
				OBJpath = getdir("Temp") + "\\objects_tempOBJ\\" + path1[j];
				if(fileexists(OBJpath) && path1[j] != null)
				{
					readFile = File( OBJpath, "r");
					if(!readFile) {error("Error when reading obj");return 0;}
					if(readFile.isOpen()) {
						while(!readFile.eof())
						{
							line = readFile.read();
							writeFile.writeln(line);
						}
						readFile.close();
					}
				}
				break;
			}
		}
		writeFile.close();
		mtlname = strleft(OBJName,OBJName.size() - 4);
		code = filecopy(getdir("Temp")+"\\octanemerge.mtl",mtlname + ".mtl");
		if(code == -1) {
			info("Failed to copy mtl");
		}
		// merge obj
		path1 = matchfiles(getdir("Temp") + "\\objects_tempOBJ\\", "*.obj");
		writeFile = File(OBJName, "w");
		totalpoints = 0;
		writeFile.writeln("o " + g_Scenename.asStr() + ".obj");
		writeFile.writeln("mtllib " + g_Scenename.asStr() + ".mtl");
		if(path1) {
			for(j=1;j<=path1.size();j++){
				OBJpath = getdir("Temp") + "\\objects_tempOBJ\\" + path1[j];

				if(fileexists(OBJpath) && path1[j] != null)
				{
					itemname = strleft(path1[j],size(path1[j]) - 4);
					item = Mesh(itemname);
					if(item != null)
					{
						readFile = File( OBJpath, "r");
						if(!readFile) {error("Error when reading obj");return 0;}
						if(readFile.isOpen()) {
							while(!readFile.eof())
							{

								line = readFile.read();
								goon = true;
								if(strleft(line,2) == "o ")
								{
									goon = false;
								}
								if(strleft(line,2) == "g ")
								{
									goon = false;
								}
								if(strleft(line,6) == "mtllib")
								{
									goon = false;
								}
								if(goon == true)
								{
									if(totalpoints == 0){
										writeFile.writeln(line);
									}else{
										if(strleft(line,1) == "f")
										{
											linepars = parse(" ",line);
											lineparstwo = parse("//",linepars[2]);
											lineparsthree = parse("//",linepars[3]);
											lineparsfour = parse("//",linepars[4]);
											if(linepars.size() > 4)
												lineparsfive = parse("//",linepars[5]);
											pointone = lineparstwo[1];
											pointtwo = lineparsthree[1];
											pointthree = lineparsfour[1];
											if(linepars.size() > 4)
												pointfour = lineparsfive[1];
											//writeFile.writeln(line);
											if(linepars.size() > 4)
												writeFile.writeln("f " + (pointone.asInt() + totalpoints.asInt() ) + "// "+ (pointtwo.asInt() + totalpoints.asInt() ) + "// " + (pointthree.asInt() + totalpoints.asInt() ) + "// " + (pointfour.asInt() + totalpoints.asInt() ) + "//");
											else
												writeFile.writeln("f " + (pointone.asInt() + totalpoints.asInt() ) + "// "+ (pointtwo.asInt() + totalpoints.asInt() ) + "// " + (pointthree.asInt() + totalpoints.asInt() ) + "//");
										}else{
										writeFile.writeln(line);
										}
									}
								}
							}
							readFile.close();
						}
						totalpoints += item.pointCount();
					}else{
						info("FYI problems loading model " + itemname);
					}
				}
			}
		}
		writeFile.close();
		// read the list and replace
		if(fileexists(getdir("Temp")+"\\lwoctane_objectlist.txt")){
			readFile = File( getdir("Temp")+"\\lwoctane_objectlist.txt", "r");
			if(!readFile) {error("Error when reading lwoctane_objectlist.txt");return 0;}
			if(readFile.isOpen()) {
				mesh = Mesh();
				while(!readFile.eof())
				{
					if(mesh.null == false){
						SelectItem(mesh.id);

						filepath = readFile.read();
						if(fileexists(filepath))
							ReplaceWithObject(filepath);
						str = string("LoadMotion ",getdir("Temp"),"\\objects_temp\\",mesh.name,".mot");
						CommandInput(str);
					}
					mesh = mesh.next();
				}
				readFile.close();
			}
		}

	}
	requpdate();
}

UseProjectButton
{
	OCSName = getfile("Select .ocs","*.ocs",getdir("Scenes"),1);
	if(!OCSName) return;

	OCSNameParse = parse("\\",OCSName);
	basepath = "";
	for(i = 1 ; i < sizeof(OCSNameParse); i++)
	{
		basepath += OCSNameParse[i] + "\\";
	}
	setvalue(ctl_octaneproject,basepath.asStr());
	projname = strleft(OCSNameParse[sizeof(OCSNameParse)],size(OCSNameParse[sizeof(OCSNameParse)]) - 4);

	setvalue(ctl_octaneproject,basepath.asStr());
	setvalue(ctl_projectname,projname.asStr());

}
save: mode, io
{
    if(mode == SCENEMODE){

	}
}

load: mode,io
{
    if(mode == SCENEMODE)
    {


    }
}

process: event, command
{

}

ctl_ForceOBJExport_change: val
{ g_ForceOBJExport = val; SaveSettings();}
ctl_samplescustom_change: val
{ g_SampleCustom = val; SaveSettings();}
ctl_scaleres_change: val
{	if(settingdefaultres == true) return;
	if(val == g_ScaleRes ) return;

	if(val == 1){ //100
		multiplier = 1;
	}else if(val == 2){ //75
		multiplier = 0.75;
	}else if(val == 3){ //50
		multiplier = 0.5;
	}else if(val == 4){ //25
		multiplier = 0.25;
	}

	g_ScaleRes = val;
	changingfromscale = true;
	setvalue(ctl_reswidth,(OriginalWidth * multiplier).asInt());
	setvalue(ctl_resheight,(OriginalHeight * multiplier).asInt());
	changingfromscale = false;
}
ctl_exportobj_change: val
{    WriteOBJHow = val; SaveSettings();}
ctl_readuv_change: val
{    WriteUVHow = val; SaveSettings();}
ctl_WriteUV_change: val
{    g_WriteUV = val; SaveSettings();}
ctl_WriteNORMAL_change: val
{	g_WriteNORMAL = val; SaveSettings(); }
ctl_GPUCheck_change: val
{    g_CheckGPU = val;}
ctl_unitsize_change: val
{	g_UnitSize = val;  SaveSettings();}
ctl_ExportSunDir_change: val
{    g_ExportSunDir = val;}
ctl_CheckFocal_change: val
{    g_CheckFocal = val;}
ctl_CheckAperture_change: val
{    g_CheckAperture = val;}
ctl_Itemname_change: val
{    g_SelectedItem = val;}
ctl_pointofintITEM_change: val
{ g_PointOfIntITEM = val;}
ctl_pointofint_change: val
{ g_PointOfInt = val; SaveSettings();}

ctl_octane_change: val
{	OctaneExePath = val;SaveSettings();}
ctl_stepframe_change: val
{	stepFrame = val;}
ctl_endframe_change: val
{	endFrame = val;}
ctl_startframe_change: val
{	startFrame = val;}
ctl_selectfolder_change: val
{    AnimOutputPath = val;SaveSettings();}
ctl_samplesdropdown_change: val
{
	samples = 8;
	if(val == 1)
		samples = 8;
	else if(val == 2)
		samples = 32;
	else if(val == 3)
		samples = 256;
	else if(val == 4)
		samples = 512;
	else if(val == 5)
		samples = 1024;
	else if(val == 6)
		samples = 4096;
	PresetSamples = val;
	setvalue(ctl_customsamples,samples);
	g_SampleCustom = samples;
	SaveSettings();
}
ctl_ResEnable_change: val
{    g_ResolutionBool = val;}
ctl_reswidth_change: val
{
	if(changingfromscale == true) return;
	g_ResWidth = val;
	OriginalWidth = val;
	settingdefaultres = true;
	setvalue(ctl_scaleres,1);
	settingdefaultres = false;
}
ctl_resheight_change: val
{
	if(changingfromscale == true) return;
	g_ResHeight = val;
	OriginalHeight = val;
	settingdefaultres = true;
	setvalue(ctl_scaleres,1);
	settingdefaultres = false;
}
ctl_aperture_change: val
{    g_Aperture = val;}
ctl_focaldepth_change: val
{    g_FocalDepth = val;}
ctl_exposure_change: val
{    g_Exposure = val;}
ctl_ExportCameraCheck_change: val
{    g_CameraBool = val;}
ctl_cameraname_change: val
{    g_SelectedCamera = val;}
ctl_MotionBlurCheck_change: val
{    m_MotionBlur = val;}
ctl_lightname_change: val
{    g_SelectedLight = val;}
ctl_interpolate_change: val
{    m_InterpolateMode = val;}
ctl_GPU_change: val
{    g_GPU = val;SaveSettings();}
ctl_octaneproject_change: val
{    g_OctaneProject = val; SaveSettings();}
ctl_projectname_change: val
{    g_Scenename = val; SaveSettings();}